# TODO: system modules: cloudpickle, loky
#
# Conditional build:
%bcond_with	doc	# Sphinx documentation (fails on missing examples???)
%bcond_without	tests	# unit tests (some memmapping tests fail under load)

Summary:	Lightweight pipelining: using Python functions as pipeline jobs
Summary(pl.UTF-8):	Lekkie przetwarzanie potokowe przy użyciu funkcji pythonowych jako zadań
Name:		python3-joblib
Version:	1.2.0
Release:	1
License:	BSD
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/joblib/
Source0:	https://files.pythonhosted.org/packages/source/j/joblib/joblib-%{version}.tar.gz
# Source0-md5:	928a19e66a10f6cda32fb004440c70fb
URL:		https://pypi.org/project/joblib/
BuildRequires:	python3-modules >= 1:3.6
BuildRequires:	python3-setuptools
%if %{with tests}
BuildRequires:	python3-lz4
BuildRequires:	python3-numpy >= 1.14
BuildRequires:	python3-pytest
BuildRequires:	python3-threadpoolctl
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python3-numpydoc
#BuildRequires:	python3-pandas
BuildRequires:	python3-sphinx_gallery
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python3-modules >= 1:3.6
Conflicts:	python3-numpy < 1:1.6.1
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Joblib is a set of tools to provide lightweight pipelining in Python.
In particular:
- transparent disk-caching of functions and lazy re-evaluation
   (memoize pattern)
- easy simple parallel computing
        
Joblib is optimized to be fast and robust on large data in particular
and has specific optimizations for numpy arrays. It is BSD-licensed.

%description -l pl.UTF-8
Joblib to zbiór narzędzi zapewniających lekkie przetwarzanie potokowe
w Pythonie. W szczególności:
- przezroczyste zapamiętywanie na dysku funkcji i leniwe ponowne
  wyliczanie (wzorzec memoize)
- łatwe, proste przetwarzanie równoległe

Biblioteka jest zoptymalizowana pod kątem szybkości i funkcjonalności,
w szczególności na dużych zbiorach danych; ma wyspecjalizowane
optymalizacje dla tablic numpy. Jest na licencji BSD.

%package apidocs
Summary:	API documentation for Python joblib module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona joblib
Group:		Documentation

%description apidocs
API documentation for Python joblib module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona joblib.

%prep
%setup -q -n joblib-%{version}

%build
%py3_build

%if %{with tests}
# disable single failing test
PYTEST_DISABLE_PLUGIN_AUTOLOAD=1 \
%{__python3} -m pytest joblib -k 'not test_parallel_call_cached_function_defined_in_jupyter'
%endif

%if %{with doc}
PYTHONPATH=$(pwd) \
%{__make} -C doc html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%py3_install

%{__rm} -r $RPM_BUILD_ROOT%{py3_sitescriptdir}/joblib/test

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc LICENSE.txt README.rst
%{py3_sitescriptdir}/joblib
%{py3_sitescriptdir}/joblib-%{version}-py*.egg-info

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc doc/_build/html/{_static,*.html,*.js}
%endif
%changelog
* Wed Jan 11 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-joblib.git;a=log;h=master

* Wed Jan 11 2023 Jakub Bogusz <qboosh@pld-linux.org> 1bb7021
- updated to 1.2.0

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> 1d9b470
- rebuild with tests and docs

* Sat Mar 26 2022 Jan Rękorajski <baggins@pld-linux.org> 8d50363
- rebuild with python 3.10

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> dffcd70
- release 2 (by relup.sh)

* Wed Jun 03 2020 Jakub Bogusz <qboosh@pld-linux.org> 3facbb2
- typo

* Wed Jun 03 2020 Jakub Bogusz <qboosh@pld-linux.org> ce9dca6
- python-joblib updated to 0.15.1 for python 3.6+

* Thu May 14 2020 Jakub Bogusz <qboosh@pld-linux.org> 5398b74
- new

